/*
Copyright 2010-2012 Sergey Levin


This file is part of crosti.

Crosti is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Crosti is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with crosti.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "colors.h"
#include "info.h"


_dmc::_dmc()
{
  load(Info::dataPath()+"/system/colors.csc");
}


QRgb _dmc::find(const QColor& cl,int pos)const
{
  QList<QRgb>result;
  int precision=500;
  for(int k=0;k<color.size();k++){
    QColor clDMC(color.at(k)._color);
    float err=YUV(clDMC).distance(YUV(cl));
    //float err=RGB(clDMC).distance(RGB(cl));
    if(err<precision){
      result.prepend(color.at(k)._color);
      precision=int(err);
    }
  }
  if((result.size()>0)&&(pos<result.size()))return result.at(pos);
  else return blank();
}


void _dmc::load(const QString &path)
{
 QFile file(path);
 if(file.open(QIODevice::ReadOnly|QIODevice::Text)){
   color.clear();
   QTextStream in(&file);
   while(!in.atEnd()){
     QString colorStr=in.readLine();
     QStringList cl=colorStr.split(";;");
     if(cl.size()>3){
       bool ok;
       colorDMC clDMC;
       clDMC._number=cl.at(0);
       clDMC._description=cl.at(1);
       cl[3].prepend("FF");
       clDMC._color=cl.at(3).toUInt(&ok,16);
       color.append(clDMC);
     }
   }
 }
}
