/*
Copyright 2010-2012 Sergey Levin


This file is part of crosti.

Crosti is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Crosti is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with crosti.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef COMBOBOXDELEGATE_H
#define COMBOBOXDELEGATE_H

#include "colors.h"

#include <QtGui>


class comboBoxDelegate:public QItemDelegate
{
    Q_OBJECT
public:
    comboBoxDelegate(QObject *parent=0);
    ~comboBoxDelegate();
    void setSize(int x,int y);

    virtual QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &,
                                  const QModelIndex &index) const;
    virtual void setModelData(QWidget *editor, QAbstractItemModel *model,
                              const QModelIndex &index) const;
    void updateEditorGeometry(QWidget *editor,
                              const QStyleOptionViewItem &option, const QModelIndex &) const{
      editor->setGeometry(option.rect);
    }

  private:
    QList<QIcon>_iconPicList;
    QList<QIcon>_iconColList;
    _dmc dmc;

    void setPicIcons(int x,int y);
    void setColIcons(int x,int y);
};

#endif // COMBOBOXDELEGATE_H
