/*
Copyright 2010-2012 Sergey Levin


This file is part of crosti.

Crosti is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Crosti is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with crosti.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef IMAGEFILTER_H
#define IMAGEFILTER_H

#include <QtGui>


//Нумерация ядра свёртки 3х3
// ______
//| 0 3 6
//| 1 4 7
//| 2 5 8

class _imageFilter
{
 public:
   _imageFilter(int edge=1);
   ~_imageFilter(){_weight.clear();}
   void setEdge(int edge=1);
   static float scaleFit(const QSize &size,int div=0);

//Медианный фильтр
   static QImage median(QImage image,QVector<QRgb>colorTable,QProgressDialog *pb=0);
//Усредняющий фильтр
   static QImage medium(QImage image,QProgressDialog *pb=0);

   QImage filter(QImage image,int mode=0,QProgressDialog *pb=0);

 private:
   static int MIDfilter(const QVector<QRgb> &colorTable,QList<int> midval);
   void setWeight(int mode=0);
   void setDiv();

   int _edge;
   qreal _div;//Сумма коэфф. свёртки
   QList<qreal>_weight;//Ядро свёртки (линейное)
};

#endif // IMAGEFILTER_H
