/*
Copyright 2010-2012 Sergey Levin


This file is part of crosti.

Crosti is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Crosti is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with crosti.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef INFO_H
#define INFO_H

#include <QtGui>



class Info:public QObject
{
    Q_OBJECT
    private:
     static QWidget *_parent;
     static QStringList messageString;
     static QString* _dataPath;

    public slots:
     void websiteVisit();
     void about();
     void aboutQt();

    public:
     enum Message{msgPrinterNotFound,msgPrinterError,msgPrintAreaError,msgImageSaveError,msgSchemeSaveError,msgOutOfMemory,msgPleaseWait};

     static void setDataPath(const QString &path){if(!_dataPath)_dataPath=new QString(path);}
     static void setParent(QWidget *parent){_parent=parent;}

     static void messageSplash(QString msgstr,int delay=4000);
     static void messageSplash(Message msgid,int delay=4000);
     static void message(QString msgstr){QMessageBox::information(_parent,APP_NAME,msgstr);}

     static QString colorSign(int i);
     static QString dataPath(){return *_dataPath;}
     static QString imageFilter(const QList<QByteArray>& baList);
     static QString message(Message msgid){return messageString.at(msgid);}
};

#endif
