/*
Copyright 2010-2012 Sergey Levin


This file is part of crosti.

Crosti is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Crosti is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with crosti.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "line.h"
#include<QPolygon>


bool Line::hasPoint(const QPoint& p)const{
  //Упрощённый алгоритм - плохо выделяет некоторые линии
  QPoint dp(4,4);
  QPolygon linePolygon;
  //Создаём два Rect с центрами в начале и конце линии и делаем из них полигон
  linePolygon<<p1()-dp<<QPoint(p1().x(),p1().y()+dp.y())<<p1()+dp<<QPoint(p1().x()+dp.x(),p1().y())
             <<p2()-dp<<QPoint(p2().x(),p2().y()+dp.y())<<p2()+dp<<QPoint(p2().x()+dp.x(),p2().y());
  return linePolygon.containsPoint(p,Qt::OddEvenFill);
}


QTextStream& operator<<(QTextStream& out,const Line& ln){
  out<<ln.p1().x()<<" "<<ln.p1().y()<<" "<<ln.p2().x()<<" "<<ln.p2().y()<<" "<<ln.width();
  return out;
}

