/*
Copyright 2010-2012 Sergey Levin


This file is part of crosti.

Crosti is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Crosti is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with crosti.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef LINE_H
#define LINE_H

#include<QLine>
#include<QPoint>
#include<QPen>
#include<QBrush>
#include<QColor>
#include<QTextStream>


class Line:public QLine
{
  uchar  _width;
  QRgb   _color;
 public:

  Line(const QPoint& p1=QPoint(),const QPoint& p2=QPoint(),uchar w=0,const QColor &cl=QColor()):
    QLine(p1,p2),_width(w),_color(cl.rgb()){}
  Line(const Line& line):QLine(line.p1(),line.p2()),_width(line._width),_color(line._color){}

  uchar          width()const{return _width;}
  bool           hasPoint(const QPoint& p)const;//Проверяет принадлежность точки к линии
  QPen           pen()const{return QPen(QBrush(_color,Qt::SolidPattern),_width);}
  QColor         color()const{return QColor(_color);}
  void           setWidth(uchar width){_width=width;}
  void           setColor(const QColor& cl){_color=cl.rgb();}
  void           clear(){setPoints(QPoint(),QPoint());}

  friend QTextStream& operator<<(QTextStream& out,const Line& ln);
};


#endif // LINE_H
