/*
Copyright 2010-2012 Sergey Levin


This file is part of crosti.

Crosti is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Crosti is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with crosti.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "previewlabel.h"


previewLabel::previewLabel(QWidget *parent,Qt::WindowFlags f):QLabel(parent,f){
      setAlignment(Qt::AlignHCenter|Qt::AlignVCenter);
      setWindowFlags(Qt::SplashScreen);
      setWindowModality(Qt::ApplicationModal);
      setGeometry(0,0,QApplication::desktop()->availableGeometry().width(),QApplication::desktop()->availableGeometry().height());
}


void previewLabel::showImage(const QImage &image){
    setPixmap(QPixmap::fromImage(image));
    show();
    grabKeyboard();
    grabMouse();
}


void previewLabel::closeEvent(QCloseEvent*){
  releaseKeyboard();
  releaseMouse();
}


void previewLabel::keyPressEvent(QKeyEvent* event){
  if(event->key()==Qt::Key_Escape)close();
}


void previewLabel::mousePressEvent(QMouseEvent *event){
  if(event->button()==Qt::RightButton)close();
}
