/*
Copyright 2010-2012 Sergey Levin


This file is part of crosti.

Crosti is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Crosti is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with crosti.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef SCHEMEDATA_H
#define SCHEMEDATA_H

#include "colors.h"

#include <QList>
#include <QImage>


class _schemeData{
 public:
   _schemeData(const QImage &image=QImage()):
     colorTable(),
     _image(image)
   {}
   ~_schemeData(){clear();}

   QImage image()const{return _image;}
   QList<QRgb> clT()const{return colorTable;}

   void setImage(const QImage &image){_image=image;}

   bool convert(const _dmc &dmc,const int clSize,int mode=0);
   bool isNull()const{if((colorTable.size()==0)||(_image.isNull()))return true;else return false;}



 private:

   QList<QRgb>colorTable;
   QImage _image;

   void clear(){
     colorTable.clear();
     _image=QImage();
   }

   int selectDistantColor(const QList<QRgb> &pickedColor,const QList<QRgb> &unpickedColor)const;

   _schemeData& operator =(const _schemeData&);//Запрещение присваивания
   _schemeData(const _schemeData&);//Запрещение конструктора копирования
};


#endif // SCHEMEDATA_H
