/*
Copyright 2010-2012 Sergey Levin


This file is part of crosti.

Crosti is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Crosti is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with crosti.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "theme.h"
#include "info.h"


void Theme::load(const QString &name){
 if(name!="")_name=name;
 _btnStyle=loadStyle("btn.qss");
 _lineeditStyle=loadStyle("lineedit.qss");
 _progressbarStyle=loadStyle("progressbar.qss");
 _menuStyle=loadStyle("menu.qss");
 _spinboxStyle=loadStyle("spinbox.qss");
 _groupboxStyle=loadStyle("groupbox.qss");
 _widgetStyle=loadStyle("widget.qss");
}


QString Theme::loadStyle(const QString &name){
 QString result="";
 if(_name!=""){
   QString path=Info::dataPath()+"/system/theme/"+_name+"/"+name;
   QFile file(path);
   if(file.open(QIODevice::ReadOnly|QIODevice::Text)){
     QTextStream in(&file);
     QTextCodec *codec=QTextCodec::codecForName("UTF8");
     in.setCodec(codec);
     result=in.readAll();
     file.close();
   }
 }
 return result;
}


