/*
Copyright 2010-2012 Sergey Levin


This file is part of crosti.

Crosti is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Crosti is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with crosti.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef THEME_H
#define THEME_H

#include <QtGui>

class Theme
{
 public:
   Theme():
     _name(),
     _btnStyle(),
     _groupboxStyle(),
     _lineeditStyle(),
     _progressbarStyle(),
     _menuStyle(),
     _spinboxStyle(),
     _widgetStyle()
   {
     QSettings rsettings(QApplication::organizationName(),QApplication::applicationName());
     load(rsettings.value("theme").value<QString>());
   }


   QString name()const{return _name;}
   QString btnStyle()const{return _btnStyle;}
   QString lineeditStyle()const{return _lineeditStyle;}
   QString progressbarStyle()const{return _progressbarStyle;}
   QString menuStyle()const{return _menuStyle;}
   QString spinboxStyle()const{return _spinboxStyle;}
   QString groupboxStyle()const{return _groupboxStyle;}
   QString widgetStyle()const{return _widgetStyle;}

   static Theme currentTheme(){
     return Theme();
   }
 

 private:
   
   void load(const QString &name="");

   QString loadStyle(const QString &name);
   
   QString _name;
   QString _btnStyle,
           _groupboxStyle,
           _lineeditStyle,
           _progressbarStyle,
           _menuStyle,
           _spinboxStyle,
           _widgetStyle;


 };


#endif // THEME_H
