/*
Copyright 2010-2012 Sergey Levin


This file is part of crosti.

Crosti is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Crosti is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with crosti.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "toolbar.h"
#include "info.h"
#include<QIcon>
#include<QString>
#include<QToolButton>
#include<QCoreApplication>


ToolBar* ToolBar::self=NULL;


ToolBar::ToolBar():btnGroup()
{
  struct attr{QString name,shortCut;};
  //Не забудь обновить ToolBar enum!!
  attr btnList[]={{QObject::trUtf8("Show color"),QObject::trUtf8("C")},
                  {QObject::trUtf8("Pipette")      ,QObject::trUtf8("D")},
                  {QObject::trUtf8("Pencil")     ,QObject::trUtf8("Space")},
                  {QObject::trUtf8("Fill")      ,QObject::trUtf8("F")},
                  {QObject::trUtf8("Lines")        ,QObject::trUtf8("L")},
                  {QObject::trUtf8("Stitches")       ,QObject::trUtf8("S")},
                  {QObject::trUtf8("Icons")       ,QObject::trUtf8("I")},
                  {QObject::trUtf8("Grid")        ,QObject::trUtf8("G")}};
  int size=sizeof(btnList)/sizeof(attr);

  for(int i=0;i<size;i++){
    QString nm=btnList[i].name;
    QString sc=btnList[i].shortCut;
    QToolButton* btn=new QToolButton;
    btn->setToolTip(nm);
    if(sc!=""){
      btn->setStatusTip(nm+" - "+QObject::trUtf8("quick key")+": "+sc);
      btn->setShortcut(sc);
    }
    btn->setIcon(QIcon(Info::dataPath()+"/system/image/tool"+QString::number(i)+".png"));
    btn->setCheckable(true);
    btnGroup.addButton(btn,i);
  }
}

