/*
Copyright 2010-2012 Sergey Levin


This file is part of crosti.

Crosti is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Crosti is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with crosti.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef VIEWER_H
#define VIEWER_H

#include <QtGui>

#include "ui_fmview.h"
#include "schemedata.h"

class viewer:public QWidget
{
 Q_OBJECT
 Q_PROPERTY(QImage image READ image WRITE setImage NOTIFY imageChanged)

 public:
   viewer(_schemeData* schemed,QWidget *parent=0);
   ~viewer();
   void setImage(const QImage &img);
   QImage image()const{return _image;}


 private slots:
   void setScale(int factor);
   void scaleResetBtnPress();
   void schemeBtnPress();

 signals:
   void imageChanged(QImage);
   void makeScheme(_schemeData*);


 private:
   Ui::fmview ui;
   QGraphicsScene *imageScene;
   QImage _image;
   _schemeData *schemeData;
};


#endif // VIEWER_H
